/****************************************************************************

 Copyright (c) 1999 Gilles Farrache In2p3 Computing Center
 All rights reserved.
  
 
 This header contains all parameters that help the readibility of software,
 either in client or server, or parameters that are common to client and
 server.
 
 common.h v 1.8.7 2000/05/23  - Header creation

*****************************************************************************/

/* COMPRESSION and NOCOMPRESSION :
**		Often used in routine call (more readable than 0 or 1)
*/
#define COMPRESSION 	1
#define NOCOMPRESSION 	0

/* ACKTO :
**		Define the time out to wait for an acknoledge. An acknoledge is sent
**		by a child to the corresponding child to say that all data have been
**		received.
**		Expressed in second, usual value 100.
*/
#define ACKTO	100

/* CONTROLSOCKTO :
**		Define the time out to wait while reading on the control socket.
**		This time out is set only if the server or the client knows that 
**		the other side  has something to send 
**		Expressed in second, usual value 30.
*/
#define CONTROLSOCKTO	30

/* SENDCONTROLTO :
**		Define the time out to wait while sending on the control socket.
**		Expressed in second, usual value 10.
*/
#define SENDCONTROLTO	10

/* DATASOCKTO :
**		Define the time out to wait while reading on the data socket.
**		This time out is set only if the server or the client knows that 
**		the other side  has something to send 
**		Expressed in second, usual value 50.
*/
#define DATASOCKTO	50

/* CHECKSTDINTO :
**      Define the time to wait for the connection on the checkreceive
**      socket by the server
**		Expressed in second, usual value 50.
*/
#define CHECKSTDINTO    50

/* NBITSINKEY :
**		Define the number of bits in the RSA Key
*/
#define NBITSINKEY	1024

/* TCPWINSIZE :
**		Define the TCP window size for the data socket.
**		Expressed in bytes, usual value is 128000 for OSF1 (more needs priviledge)
**		and 256000 for the others OS.
*/
#ifdef OSF1
#define TCPWINSIZE	128000
#else
#define TCPWINSIZE	256000
#endif
